
%% zinnen en bijzinnen

s(b(s,[Boom1,Boom2,Boom3])) --> np(Number,Boom1), v(fin,Number,Boom2),   vp(no_v,Boom3).
s(b(s,[Boom1,Boom2,Boom3])) --> np(Number,Boom1), aux(fin,Number,Boom2), vp(no_aux,Boom3).
s(b(s,[Boom1,Boom2,Boom3])) --> np(Number,Boom1), mod(fin,Number,Boom2), vp(no_mod,Boom3).

cp(b(cp,[Boom1,Boom2,Boom3])) --> compl(Boom1), np(Number,Boom2), v(fin,Number,Boom3).

compl(b(compl,[w(Word)])) --> [Word], {compl(Word)}.

%% vp's en vc's

vp(V,b(vp,[Boom])) --> vc(V,Boom).
vp(V,b(vp,[Boom1,Boom2])) --> np(_,Boom1), vp(V,Boom2).
vp(V,b(vp,[Boom1,Boom2])) --> pp(Boom1)  , vp(V,Boom2).
vp(V,b(vp,[Boom1,Boom2])) --> adv(Boom1) , vp(V,Boom2).

vp(V,b(vp,[Boom1,Boom2])) --> vc(V,Boom1), pp(Boom2).
vp(V,b(vp,[Boom1,Boom2])) --> vc(V,Boom1), cp(Boom2).

vc(V,b(vc,[Boom])) --> v(V,_,Boom).
vc(V,b(vc,[Boom1,Boom2])) --> aux(V,_,Boom1), v(prt,_,Boom2).
vc(V,b(vc,[Boom1,Boom2])) --> mod(V,_,Boom1), v(inf,_,Boom2).
vc(V,b(vc,[Boom1,Boom2])) --> v(prt,_,Boom1), aux(V,_,Boom2).
vc(V,b(vc,[Boom1,Boom2])) --> v(inf,_,Boom1), mod(V,_,Boom2).

%% werkwoorden

aux(fin,single,b(aux,[w(Word)]))    --> [Word], {auxiliary(Word,_)}.
aux(fin,plural,b(aux,[w(Word)]))    --> [Word], {auxiliary(_,Word)}.
aux(no_aux,_  ,b(aux,[w(epsilon)])) --> [].

mod(fin,single,b(mod,[w(Word)]))    --> [Word], {modal(Word,_)}.
mod(fin,plural,b(mod,[w(Word)]))    --> [Word], {modal(_,Word)}.
mod(no_mod,_  ,b(mod,[w(epsilon)])) --> [].

v(fin,single,b(v,[w(Word)])) --> [Word], {verb(Word,_,_,_)}.
v(fin,single,b(v,[w(Word)])) --> [Word], {verb(_,Word,_,_)}.
v(fin,plural,b(v,[w(Word)])) --> [Word], {verb(_,_,_,Word)}.
v(prt,na    ,b(v,[w(Word)])) --> [Word], {verb(_,_,Word,_)}.
v(inf,na    ,b(v,[w(Word)])) --> [Word], {verb(_,_,_,Word)}.
v(no_v,na   ,b(v,[w(epsilon)])) --> []. 

%% np's

np(single,b(np,[Boom1,Boom2])) --> det(een,single,Boom1), n(de,single,e,Boom2).         % een mooie jongen
np(single,b(np,[Boom1,Boom2])) --> det(een,single,Boom1), n(het,single,no_e,Boom2).     % een mooi meisje
np(single,b(np,[Boom1,Boom2])) --> det(de ,single,Boom1), n(de,single,e,Boom2).         % de mooie jongen
np(single,b(np,[Boom1,Boom2])) --> det(het,single,Boom1), n(het,single,e,Boom2).        % het mooie meisje
np(plural,b(np,[Boom1,Boom2])) --> det(de ,plural,Boom1), n(_,plural,e,Boom2).          % de mooie jongens, de mooie meisjes

np(single,b(np,[Boom1,Boom2,Boom3])) --> det(een,single,Boom1), n(de,single,e,Boom2),     pp(Boom3).     % een mooie jongen op de trap, etc. 
np(single,b(np,[Boom1,Boom2,Boom3])) --> det(een,single,Boom1), n(het,single,no_e,Boom2), pp(Boom3). 
np(single,b(np,[Boom1,Boom2,Boom3])) --> det(de ,single,Boom1), n(de,single,e,Boom2),     pp(Boom3). 
np(single,b(np,[Boom1,Boom2,Boom3])) --> det(het,single,Boom1), n(het,single,e,Boom2),    pp(Boom3).
np(plural,b(np,[Boom1,Boom2,Boom3])) --> det(de ,plural,Boom1), n(_,plural,e,Boom2),      pp(Boom3).  

det(Det,Number,b(det,[w(Word)])) --> [Word], {determiner(Det,Word,Number)}. 

n(Lidw,Number,E,b(n,[Boom1,Boom2])) --> a(E,Boom1), n(Lidw,Number,E,Boom2).
n(Lidw,single,_,b(n,[w(Word)])) --> [Word], {noun(Lidw,Word,_)}.
n(Lidw,plural,_,b(n,[w(Word)])) --> [Word], {noun(Lidw,_,Word)}.

a(no_e,b(a,[w(Word)])) --> [Word], {adjective(Word,_)}.
a(e,b(a,[w(Word)]))    --> [Word], {adjective(_,Word)}.

%% pp's

pp(b(pp,[Boom1,Boom2])) --> prep(Boom1), np(_,Boom2).

prep(b(prep,[w(Word)])) --> [Word], {preposition(Word)}.

%% adv's

adv(b(adv,[w(Word)])) --> [Word], {adverb(Word)}.

%% woordenboek

adverb(hier).
adverb(vandaag).
adverb(morgen).
adverb(daar).
adverb(gisteren).

preposition(voor).
preposition(tegen).
preposition(aan).
preposition(boven).
preposition(over).

adjective(bruin,bruine).
adjective(gevaarlijk,gevaarlijke).
adjective(zeldzaam,zeldzame).
adjective(exotisch,exotische).
adjective(roze,roze).

adjective(mooi,mooie).
adjective(lelijk,lelijke).
adjective(verwerpelijk,verwerpelijke).
adjective(dramatisch,dramatische).
adjective(geel,gele).

noun(de,beer,beren).
noun(de,hond,honden).
noun(de,flamingo,flamingos).
noun(de,olifant,olifanten).
noun(de,directeur,directeuren).
noun(het,beest,beesten).
noun(het,dier,dieren).
noun(het,paard,paarden).

noun(de,jongen,jongens).
noun(het,meisje,meisjes).
noun(het,jongetje,jongetjes).
noun(de,meid,meiden).
noun(de,man,mannen).

determiner(de,de,single).    % de jongen
determiner(de,de,plural).    % de jongens

determiner(het,het,single).  % het meisje
determiner(het,de,plural).   % de meisjes

determiner(een,een,single).  % een meisje, een jongen


auxiliary(heeft,hebben).

modal(wil,willen).

verb(denkt,dacht,gedacht,denken).
verb(voert,voerde,gevoerd,voeren).
verb(verhuurt,verhuurde,verhuurd,verhuren).
verb(nadert,naderde,genaderd,naderen).
verb(ontsnapt,ontsnapte,ontsnapt,ontsnappen).
verb(schrikt,schrok,geschrokken,schrikken).
verb(snurkt,snurkte,gesnurkt,snurken).

verb(ruikt,rook,geroken,ruiken).
verb(ziet,zag,gezien,zien).
verb(hoort,hoorde,gehoord,horen).
verb(voelt,voelde,gevoeld,voelen).
verb(loopt,liep,gelopen,lopen).

compl(dat).

%%%%%%%%%%%%%%%% testing example sentences %%%%%%%%%%%%%%%%%%%%%%%%

sentence(1,[de,beer,ontsnapt]).
sentence(2,[de,directeur,voert,de,olifant]).
sentence(3,[de,directeur,voert,de,olifanten]).
sentence(4,[de,directeur,voert,de,olifant,over,de,beer]).
sentence(5,[de,directeur,voert,over,de,beer,de,olifant]).
sentence(6,[de,directeur,voert,de,olifant,vandaag]).
sentence(7,[de,directeur,voert,de,olifant,hier]).
sentence(8,[de,directeur,heeft,de,olifanten,gevoerd]).
sentence(9,[de,directeur,wil,de,olifanten,voeren]).
sentence(10,[het,mooie,meisje,ontsnapt]).
sentence(11,[een,mooi,meisje,ontsnapt]).
sentence(12,[de,mooie,meisjes,ontsnappen]).
sentence(13,[de,mooie,jongen,ontsnapt]).
sentence(14,[een,mooie,jongen,ontsnapt]).
sentence(15,[de,mooie,jongens,ontsnappen]).

ungrammatical(1,[het,beer,ontsnapt]).
ungrammatical(2,[de,directeur,de,beer,voert]).
ungrammatical(3,[de,exotische,jongens,ontsnapte]).
ungrammatical(4,[de,directeur,vandaag,voert,de,olifant]).
ungrammatical(5,[vandaag,de,directeur,voert,de,olifant]).
ungrammatical(6,[de,directeur,heeft,de,olifant,voeren]).
ungrammatical(7,[de,directeur,wil,de,olifant,gevoerd]).
ungrammatical(8,[de,directeur,voeren]).
ungrammatical(9,[de,directeuren,voert]).
ungrammatical(10,[de,directeuren,wil,voeren]).
ungrammatical(11,[de,directeur,willen,voeren]).
ungrammatical(12,[de,directeur,hebben,gevoerd]).
ungrammatical(13,[de,directeuren,heeft,gevoerd]).
ungrammatical(14,[het,mooi,meisje,ontsnapt]).
ungrammatical(15,[een,mooie,meisje,ontsnapt]).
ungrammatical(16,[de,mooi,meisjes,ontsnappen]).
ungrammatical(17,[de,mooi,jongen,ontsnapt]).
ungrammatical(18,[een,mooi,jongen,ontsnapt]).
ungrammatical(19,[de,mooi,jongens,ontsnappen]).

test :-
    test_sentence(1),
    test_ungrammatical(1).

%% NB if add extra arguments to s, you should adapt the
%% call to s in the code below as well.

test_sentence(X) :-
    sentence(X,Sentence),
    ( s(_,Sentence,[])
    ->	format("ok ~w ~w~n",[X,Sentence])
    ;   format("parse failed ~w ~w~n",[X,Sentence])
    ),
    X1 is X + 1,
    test_sentence(X1).
test_sentence(_).

test_ungrammatical(X) :-
    ungrammatical(X,Sentence),
    ( s(_,Sentence,[])
    ->	format("falsely accepted ~w ~w~n",[X,Sentence])
    ;   format("correctly rejected ~w ~w~n",[X,Sentence])
    ),
    X1 is X + 1,
    test_ungrammatical(X1).
test_ungrammatical(_).

%%%%%%%%%%%%%% pretty print tree structures %%%%%%%%%%%%%%%%%%%%%%%

%% pprint a tree
pprint_tree(Tree) :-
	pprint_this_line(Tree,0,0),
	nl, nl.

%% parse a string, and pprint the result
parse(String) :-
    s(Tree,String,[]),
    pprint_tree(Tree),
    fail.
parse(_).

/*
pretty printer voor (horizontaal) printen van bomen van de vorm

Tree is van de vorm: b(Knoop,Dochters). Knoop moet een atom zijn (geen prolog term).  
Dochters is een lijst.

vb: b(np,[b(det,[w(de)]),b(n,[w(man)]),b(pp,[b(p,[w(uit)]),b(np,[w(groningen)])])])

Heb je labels/knopen die langer dan 6 posities zijn, dan moet je 8 en 6 in decode
hieronder door hogere getallen vervangen (bv 12 en 10). De code maakt gebruik van
de sicstus prolog built-in format/2, zie de sicstus manual voor tekst en uitleg. 
*/

pprint_this_line(b(Mother,Daughters),Indent,Dashes) :-
    format(' ~*c ~a',[Dashes,45,Mother]),
    dashes(Mother,NewDashes),
    NewIndent is Indent + 8, 
    pprint_daughters(Daughters,NewIndent,NewDashes).
pprint_this_line(w(Word),_,Dashes) :-
    format(' ~*c ~a',[Dashes,45,Word]).

pprint_next_line(b(Mother,Daughters),Indent,Dashes) :-
    Spaces is Indent - Dashes, 
    format('~n~*c ~*c ~a',[Spaces,32, Dashes,45,Mother]),
    dashes(Mother,NewDashes),
    NewIndent is Indent + 8, 
    pprint_daughters(Daughters,NewIndent,NewDashes).

pprint_daughters([D|Ds],Indent,Dashes) :-
    pprint_this_line(D,Indent,Dashes),
    pprint_next_daughters(Ds,Indent,Dashes). 
    
pprint_next_daughters([],_,_).
pprint_next_daughters([D|Ds],Indent,Dashes) :-
    pprint_next_line(D,Indent,Dashes),
    pprint_next_daughters(Ds,Indent,Dashes).

dashes(Atom,N) :-
    name(Atom,Chars),
    length(Chars,C),
    N is 6 - C.

    

